您的位置:首页 > 编程语言

leetcode:292 Nim Game-每日编程第一题

2015-12-10 14:23 393 查看



[title3]Nim Game[/title3]

Total Accepted: 24894 Total Submissions: 49816 Difficulty: Easy



You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the
first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

思路:

1).当石子数量为4*n时,无论A取1〜3个石头,B都可取3〜1个石头,使得每一轮石子总数-4,因此B可以确保取胜,A输。

2).当石子总数为其他情况时,A可取1~3个石头,使得石子总数变成4*n,跟据1).的分析,B此时必输,A胜。

因此,当石子数量为 4*n时,A输,其他情况A胜。

<span style="font-weight: normal;">class Solution {
public:
    bool canWinNim(int n) {
        if(0==n%4) 
            return false;
        else
            return true;
    }
};</span>


内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: